using J4L.RReport;
using System;
using System.Data.OleDb;
using System.Drawing;
using System.Windows.Forms;

public class exampleDBOrder:RAreaListener
{
	
  int total=0;	
 	
 	
// entry point	
public static void Main(string[] args)
{		
    exampleDBOrder f=new exampleDBOrder();
	f.init();	
 }
 
 public void init() {
		
		 // load report from file
		Report report=new Report();
 	
	 	// This is the code you must use if you need to change the database connection
		// OleDbConnection dbconnection=new OleDbConnection();
		// dbconnection.ConnectionString="Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\j4l\\ReportVD\\RReport2bis.mdb";
		// dbconnection.Open();
		// report.setDBCon(dbconnection); 		

					   
		   if (!report.importReport("examples\\DatabaseSource\\DBorder.rep")) {
		   	Console.WriteLine("Error, exiting");
		   	Application.Exit();
		   }

		// This is the code you must use if you need to change the SQL statement
		//((RDatabaseSource) report.getReportHeader().getDataSource()).setSQL("Select * from PurchaseOrderBis");
		//((RDatabaseSource) report.getAreaByName("Detail").getDataSource()).setSQL("Select * from PurchaseOrderLines");

		// set the images for the combo box. This can only be done programatically
		Image[] comboImages=new Image[3];
		comboImages[0]=new RImageFile("images/ball1.gif").getImage();
		comboImages[1]=new RImageFile("images/ball2.gif").getImage();
		comboImages[2]=new RImageFile("images/ball3.gif").getImage();
		((RCombo) report.getAreaByName("Detail").getItemByName("Priority")).Values=comboImages;
		
		// set listener to calculate amounts on the fly
		report.getAreaByName("Detail").setListener(this);
		report.getReportFooter().setListener(this);
		
		
		// create preview window	  
		RReportWindow Win= new RReportWindow(report);

		// this will print the Header Area and all dependent areas
		Console.WriteLine("Preparing report");
		report.prepare();
		Console.WriteLine("End report");
		report.endReport();
 		Console.WriteLine("Show preview window");
		Win.ShowNow();	
 	
 		Application.Exit();
		
 
 }
 
 public void beforePrintingArea(RArea area) {
	 
   // calculate the amount	of each line
	 if (area.getName().CompareTo("Detail")==0) {
		 double price=((Double) area.getItemByName("Price").getruntimeValue());
		 int quantity=((Int32) area.getItemByName("Quantity").getruntimeValue());
		 total=(int) (total+(quantity*price));
		 area.getItemByName("Amount").setruntimeValue((Int32) quantity*price);
	 }
	 
   // set total amount
	 if (area.getName().CompareTo("Footer")==0) {
		 area.getItemByName("Total").setruntimeValue(( (Int32) total));
		 total=0;
	 }
 
 }
	
	
}
